{{
VGA 640x480 80x60 8x8 pixel font console driver with color per character
(c) 2013 Perry Harrington

Based on simple 640x480 driver by Chip Gracey

}}

' P4 = VSYNC
' P3 = RED
' P2 = GREEN
' P1 = BLUE
' P0 = HSYNC

CON

  _clkmode = xinput
  _xinfreq = 60_000_000

  s = 44	'scales DAC output (s = 0..128)


DAT		org	0

'start		jmp	#begin
'		nop
'font		file	"THIN8x8prop.bin"	'127 8x8 characters

'begin		mov	start, #0
'		not	start
'		not	start+1



		setctra	#%00111			'set ctra for PLL*8
                setfrqa	frqa_			'set frqa

		setvid	#%0100			'set vid for vga output
		setvidy	vidy_			'set yiq coefficients
		setvidi	vidi_
		setvidq	vidq_

		cfgdacs	#%11_11_11_11		'set dacs to video mode

		cfgpins	pinmask,pindacs		'set pins for dac outputs

		mov	buf, #%000_000_00
		shl	buf, #8
		or	buf, #0
		setptrb	buffer
'		addptrb	rowbytes
		repd	bufsize, #3
		nop
		nop
		nop

		wrword	buf, ptrb++
		add	buf, inc
		and	buf, mask


{		setptrb	buffer
		addptrb	rowbytes
		mov	buf, #fox
		shl	buf, #0
		add	buf, cogbase
		call	#print_string
}

		'swap nibbled in BMP font
		reps	#$1000, #6
		setptrb	font

		rdbyte	c, ptrb++
		mov	buf, c
		shl	buf, #4
		shr	c, #4
		or	buf, c
		wrbyte	buf, ptrb[-1]		
'
'
' Field loop
'

field
'		setptrb	buffer
'		mov	buf, profile
'		call	#print_num
'0
	        mov	x, top_blank		'top blanks
		call	#blank			'16+48=96+640 * 33 = 52800 clocks
'52525

		mov	offset, buffer
		mov	row, rows
		mov	scan, #0

                mov     x,lines_vis		'set visible lines
'52529

	
scanline

		call	#sync			'do horizontal sync 1404 actual
		mov	incnum, #0
		call	#renderscanline

		call	#sync	
		mov	incnum, #1		'do horizontal sync 1404 actual
		call	#renderscanline

		djnz    x,#scanline           	'another line?

                mov     x, bot_blank		'bottom blanks
		call	#blank			'640+320 * 10 = 9600 clocks

		setp	#0			'do vertical sync
		mov	x,vsync			'640+320 * 2 = 1920 clocks
		call	#blank
		clrp	#0

                jmp     #field                  'field loop


blank		call	#sync			'blank lines 320 clocks
		waitvid	v640,sync_color0	'1280 clocks
		djnz	x,#blank
blank_ret	ret

sync						'horizontal sync
sync_ret	retd
		waitvid	v16,sync_color0		'16 * 2 = 32 clocks
		waitvid	v96,sync_color1		'96 * 2 = 192 clocks
		waitvid	v48,sync_color0		'48 * 2 = 96 clocks

renderscanline
		mov	colors, #0
		mov	nibble, scan
		setf	%0_0001_0001
		hubop
		shl	nibble, #2
		add	nibble, font

		mov	cmode, mode

		repd	cols, #12		

		setptra	offset			'read same row for 8 scanlines
		nop
		setspa	#0

		rdword	char, ptra++		'1,2,3	start
		mov	fgcolor, char		'4	fgcolor in high byte
		and	char, #$7F		'5	mask char offset
		shl	char, #5		'6	8 bytes per char

		add	char, nibble		'7	base of font table and scanline byte

		shr	fgcolor, #8		'8	get fgcolor from high byte
		rdlong	buf, char		'9,10,11
		movd	colors, fgcolor
		waitvid	cmode, colors		'13	render 8 pixels from long

		nop
		add	cmode, modeinc		'15	goto next stack address
		pusha	buf			'16

		add	scan, incnum		'inc scanline counter
		cmp	incnum, #1 wz		'if repeating line, don't increment
if_z		and	scan, #%111 wz		'if overflow to 8, reset to 0
if_z		add	offset, rowbytes	'if overflow, goto next row
if_z		cmpsub	row, #1 wc		'if new row, subtract 1 and test for 0
if_z_and_nc	mov	offset, buffer		'if row countdown is zero, restart page
if_z_and_nc	mov	row, rows		'restart page
renderscanline_ret	ret

print_num
		mov	y,#8			'pre-rotate to get 1st nibble in top
		shl	y,#2
		ror	buf,y

		mov	y,#8			'print nibbles
:loop		rol	buf,#4
		mov	c,buf
		and	c,#$F			'isolate nibble
		cmp	c,#$A		wc	'alpha or numeric?
	if_c	add	c,#"0"			'numeric
	if_nc	add	c,#"A"-$A		'alpha
		or	c,color
		wrword	c, ptrb++
		djnz	y,#:loop
		
print_num_ret	ret

print_string

		setptra	buf
:loop		rdbytec	c, PTRA++	wz
if_nz		or	c, color
if_nz		wrword	c, PTRB++
if_nz		jmp	#:loop		
		
print_string_ret	ret

'
'
' Initialized data
'
scan		long	0
colors		long	0
buffer		long	$5000
offset		long	0
char		long	0
buf		long	0
cols		long	39	' cols / 4
rows		long	29	' good old 40x25!
rowbytes	long	80	' bytes per row
bufsize		long	40*30
row		long	0
nibble		long	0
c		long	0
y		long	0
fgcolor		long	0
bgcolor		long	%0_000_000_000 << 9 + $00
inc		long	%000_000_01_0000_0001
mask		long	$0000_0F_7F
incnum		long	1
color		long	$FF_00
profile		long	0
cogbase		long	$E80
font		long	$2000

frqa_		long	$1000_0000		'30MHz

vidy_		long	$00_01_00_00 * s	'red gain
vidi_		long	$00_00_01_00 * s	'green gain
vidq_		long	$00_00_00_01 * s	'blue gain

pinmask		long	%1111			'pin mask for P0..P3
pindacs		long	%1111_101100000		'pin configuration for video DAC

		'	color base	mode		clocks/pixel	clocks/waitvid
mode		long	$00 << 24 +	%1001 << 20 +	2 << 13 +	16
cmode		long	0
modeinc		long	$01 << 24

lines_vis	long	240	'actual drawn lines

sync_color0	long	$0_000000
sync_color1	long	$1_000000

v16		long	16
v96		long	96
v48		long	48
v640		long	640
top_blank	long	33	'added 40 lines for masking 480 orig 33
bot_blank	long	10	'added 40 lines to mask orig 10
vsync		long	2

x		long	0
fox		byte	"The quick brown fox jumped over the lazy dog.",0